/* 
 * Copyright (C) 2001-2005 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ABOUT_DLG_H
#define ABOUT_DLG_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../client/HttpConnection.h"
#include "../client/SimpleXML.h"

static const TCHAR thanks[] = _T("Dekuji za pomoc vsem kteri se na tomto programku podileli.\r\n")
_T("Nejvetsi diky patri Trpaslikovi za jeho barevny chat a spoustu dalsich veci ...\r\n")
_T("Dalsi velke diky pro createagaga ze velikou pomoc se vsim s cim sem si nevedel rady a zrejme by sem bez neho nedal dohromady.\r\n")
_T("Taky nesmim zapomenout podekovat Silbertovi za ikonky ;o)\r\n")
_T("A samozrejme diky i vsem ostatnim ktere tu jsem linej vyjmenovat :-D");

class AboutDlg : public CDialogImpl<AboutDlg>, private HttpConnectionListener, private TimerManagerListener
{
public:
	enum { IDD = IDD_ABOUTBOX };
	enum { WM_VERSIONDATA = WM_APP + 53 };

	AboutDlg() { };
	virtual ~AboutDlg() { };

	BEGIN_MSG_MAP(AboutDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_VERSIONDATA, onVersionData)
		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/) {
		SetDlgItemText(IDC_VERSION, _T("CZDC++ v") _T(VERSIONSTRING) _T("[") _T(CZDCVERSIONSTRING) _T("]\n\nhttp://www.czdc.org\n\nby PPK\n\nCZDC++ is licenced under GNU GPL"));
		CEdit ctrl(GetDlgItem(IDC_THANKS));
		ctrl.FmtLines(TRUE);
		ctrl.AppendText(thanks, TRUE);
		ctrl.Detach();
		SetDlgItemText(IDC_TTH, WinUtil::tth.c_str());
		SetDlgItemText(IDC_LATEST, CTSTRING(DOWNLOADING));

		char buf[256];
		sprintf(buf, "Uptime: %s", WinUtil::formatTime(SETTING(TOTAL_UPTIME)).c_str());
		SetDlgItemText(IDC_TOTAL_UPTIME, Text::toT(buf).c_str());
		sprintf(buf, "Upload: %s, Download: %s", Util::formatBytes(SETTING(TOTAL_UPLOAD)).c_str(), Util::formatBytes(SETTING(TOTAL_DOWNLOAD)).c_str());
		SetDlgItemText(IDC_TOTALS, Text::toT(buf).c_str());
		if(SETTING(TOTAL_DOWNLOAD) > 0) {
			sprintf(buf, "Ratio (up/down): %.2f", ((double)SETTING(TOTAL_UPLOAD)) / ((double)SETTING(TOTAL_DOWNLOAD)));
			SetDlgItemText(IDC_RATIO, Text::toT(buf).c_str());
		}
		sprintf(buf, "Uptime: %s", WinUtil::formatTime(Util::getUptime()).c_str());
		SetDlgItemText(IDC_UPTIME, Text::toT(buf).c_str());
		sprintf(buf, "Upload: %s, Download: %s", Util::formatBytes(Socket::getTotalUp()).c_str(), Util::formatBytes(Socket::getTotalDown()).c_str());
		SetDlgItemText(IDC_ACTUALS, Text::toT(buf).c_str());
		if(Socket::getTotalDown() > 0) {
			sprintf(buf, "Ratio (up/down): %.2f", ((double)Socket::getTotalUp()) / ((double)Socket::getTotalDown()));
			SetDlgItemText(IDC_ACTUAL_RATIO, Text::toT(buf).c_str());
		}
		CenterWindow(GetParent());
		c.addListener(this);
		c.downloadFile("http://www.czdc.org/version.xml");
		TimerManager::getInstance()->addListener(this);
		return TRUE;
	}

	LRESULT onVersionData(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/) {
		tstring* x = (tstring*) wParam;
		SetDlgItemText(IDC_LATEST, x->c_str());
		delete x;
		return 0;
	}
		
	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/) {
		TimerManager::getInstance()->removeListener(this);
		Sleep(100);
		EndDialog(wID);
		return 0;
	}
private:
	HttpConnection c;

	AboutDlg(const AboutDlg&) { dcassert(0); };
	
	virtual void on(HttpConnectionListener::Data, HttpConnection* /*conn*/, const u_int8_t* buf, size_t len) throw() {
		downBuf.append((char*)buf, len);
	}

	virtual void on(HttpConnectionListener::Complete, HttpConnection* conn, const string&) throw() {
		if(!downBuf.empty()) {
			SimpleXML xml;
			xml.fromXML(downBuf);
			if(xml.findChild("Version")) {
				string version = xml.getChildAttrib("ActualVersion");
				version += "[" + xml.getChildAttrib("SubVersion") + "]";
				tstring* x = new tstring(Text::toT(version));
				PostMessage(WM_VERSIONDATA, (WPARAM) x);
			}
		}
		conn->removeListener(this);
	}

	virtual void on(HttpConnectionListener::Failed, HttpConnection* conn, const string& aLine) throw() {
		tstring* x = new tstring(Text::toT(aLine));
		PostMessage(WM_VERSIONDATA, (WPARAM) x);
		conn->removeListener(this);
	}

	virtual void on(TimerManagerListener::Second type, u_int32_t aTick) throw() {
		static char buf[256];
		sprintf(buf, "Uptime: %s", WinUtil::formatTime(Util::getUptime()).c_str());
		SetDlgItemText(IDC_UPTIME, Text::toT(buf).c_str());
		sprintf(buf, "Upload: %s, Download: %s", Util::formatBytes(Socket::getTotalUp()).c_str(), Util::formatBytes(Socket::getTotalDown()).c_str());
		SetDlgItemText(IDC_ACTUALS, Text::toT(buf).c_str());
    }
    
	virtual void on(TimerManagerListener::Minute type, u_int32_t aTick) throw() {
		static char buf[256];
		if(Socket::getTotalDown() > 0) {
			sprintf(buf, "Ratio (up/down): %.2f", ((double)Socket::getTotalUp()) / ((double)Socket::getTotalDown()));
			SetDlgItemText(IDC_ACTUAL_RATIO, Text::toT(buf).c_str());
		}
		sprintf(buf, "Uptime: %s", WinUtil::formatTime(SETTING(TOTAL_UPTIME)).c_str());
		SetDlgItemText(IDC_TOTAL_UPTIME, Text::toT(buf).c_str());
		sprintf(buf, "Upload: %s, Download: %s", Util::formatBytes(SETTING(TOTAL_UPLOAD)).c_str(), Util::formatBytes(SETTING(TOTAL_DOWNLOAD)).c_str());
		SetDlgItemText(IDC_TOTALS, Text::toT(buf).c_str());
		if(SETTING(TOTAL_DOWNLOAD) > 0) {
			sprintf(buf, "Ratio (up/down): %.2f", ((double)SETTING(TOTAL_UPLOAD)) / ((double)SETTING(TOTAL_DOWNLOAD)));
			SetDlgItemText(IDC_RATIO, Text::toT(buf).c_str());
		}
	}
	string downBuf;
};

#endif // ABOUT_DLG_H

/* Some parts Copyright (C) 2002-2005 Petr Kozelka, PPK at seznam dot cz */
